Public Class Form1
    Private m_Filter(,) As Integer
    Private m_Weight As Integer

    ' Initialize the filter.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_Filter = New Integer(,) { _
            {-1, 0, 0}, _
            {0, 0, 0}, _
            {0, 0, 1}}
        m_Weight = 1
    End Sub

    ' Open a file.
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If ofdOldFile.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Using bm As New Bitmap(ofdOldFile.FileName)
                picOld.Image = bm.Clone()
            End Using

            ApplyFilter()
        End If
    End Sub

    ' Apply the filter to the image.
    Private Sub ApplyFilter()
        Me.Cursor = Cursors.WaitCursor
        picNew.Image = Nothing
        Me.Refresh()
        Dim start_time As Date = Now

        Dim bm1 As Bitmap = picOld.Image
        Dim bm2 As New Bitmap(bm1.Width, bm1.Height)

        ' Make BitmapBytesRGB24 objects for the bitmaps.
        Dim bm1_bytes As New BitmapBytesRGB24(bm1)
        Dim bm2_bytes As New BitmapBytesRGB24(bm2)

        ' Lock the bitmaps' bytes.
        bm1_bytes.LockBitmap()
        bm2_bytes.LockBitmap()

        Dim wid As Integer = bm1.Width
        Dim hgt As Integer = bm1.Height
        Dim new_r As Byte = 0
        Dim new_g As Byte = 0
        Dim new_b As Byte = 0
        For x As Integer = 1 To wid - 2
            For y As Integer = 1 To hgt - 2
                Dim r As Integer = 0
                Dim g As Integer = 0
                Dim b As Integer = 0
                For dx As Integer = 0 To 2
                    For dy As Integer = 0 To 2
                        bm1_bytes.GetPixel(x + dx - 1, y + dy - 1, new_r, new_g, new_b)
                        r += new_r * m_Filter(dx, dy)
                        g += new_g * m_Filter(dx, dy)
                        b += new_b * m_Filter(dx, dy)
                    Next dy
                Next dx

                r = CInt(127 + r / m_Weight)
                g = CInt(127 + g / m_Weight)
                b = CInt(127 + b / m_Weight)
                If r < 0 Then r = 0
                If g < 0 Then g = 0
                If b < 0 Then b = 0
                If r > 255 Then r = 255
                If g > 255 Then g = 255
                If b > 255 Then b = 255
                bm2_bytes.SetPixel(x, y, r, g, b)
            Next y
        Next x

        ' Unlock the bitmaps.
        bm1_bytes.UnlockBitmap()
        bm2_bytes.UnlockBitmap()

        Dim stop_time As Date = Now
        Dim elapsed_time As TimeSpan = stop_time - start_time
        Debug.WriteLine(elapsed_time.TotalSeconds.ToString("0.00") & " seconds")
        picNew.Image = bm2
        picNew.Refresh()
        Me.Cursor = Cursors.Default
    End Sub
End Class
